Rendered at 20:14:44 GMT+0000 (Coordinated Universal Time) with Cloudflare Workers.
liendolucas 49 minutes ago [-]
This qualifies as pure obscure wizardry. Hats off to the author.
Agingcoder 10 hours ago [-]
Having used these machines, this is mind boggling.
blackhaz 4 hours ago [-]
I remember literally seeing how text appears on the screen once you type "dir". Video? Colors? Are you joking?
benlivengood 1 hours ago [-]
DOS and the BIOS were exceptionally slow at text. Essentially one character at a time winding their way through DOS to the BIOS and back.
Direct access to the text mode segment (0xb800 if I remember correctly) was much faster. The fonts were blitted out by hardware for every scan line, so you just changed the few thousand bytes of video memory at hundreds of thousands of bytes per second.
vasac 3 hours ago [-]
Same. Then I switched from XT to AT (8086->286), the disk was faster too, so I was forced to learn /p parameter :)
notorandit 2 hours ago [-]
The mindboggling part is when you compare hardware constraints against software.
akoboldfrying 10 hours ago [-]
Always cool to see this come up. I really like the idea of "encoding" the video as... x86 machine instructions!
The hairsplitting nerd in me can't help but point out that the claim in the Part 2 article that the problem of combining deltas is NP hard isn't true. In fact you can solve this optimally in O(n^3) time with DP: Let g(i, j) be the minimum number of bytes needed to encode input deltas i..j as a single (i.e., combined) output delta. Given g(i, j), computing g(i, j+1) takes constant time, so we can compute all of this function's values in O(n^2) total time. Now let f(i, j) be the minimum number of bytes needed to encode input deltas i..j using any sequence of output deltas (combined or not). Note that any such sequence must consist of some number (possibly zero) of optimally encoded output deltas followed by an optimally encoded output delta that itself ends with input delta j. IOW, it must be that f(i, j) is equal to f(i, k) + g(k+1, j) for some k, and there are at most n values of k that we need to try, so we can compute each value of f() in O(n); there are O(n^2) values to compute, so O(n^3) time overall. f(1, n) is then the minimum number of bytes needed to encode the entire list of input deltas, and standard backtracing through the DP matrix can be used to recover the actual sequence of output deltas.
Direct access to the text mode segment (0xb800 if I remember correctly) was much faster. The fonts were blitted out by hardware for every scan line, so you just changed the few thousand bytes of video memory at hundreds of thousands of bytes per second.
The hairsplitting nerd in me can't help but point out that the claim in the Part 2 article that the problem of combining deltas is NP hard isn't true. In fact you can solve this optimally in O(n^3) time with DP: Let g(i, j) be the minimum number of bytes needed to encode input deltas i..j as a single (i.e., combined) output delta. Given g(i, j), computing g(i, j+1) takes constant time, so we can compute all of this function's values in O(n^2) total time. Now let f(i, j) be the minimum number of bytes needed to encode input deltas i..j using any sequence of output deltas (combined or not). Note that any such sequence must consist of some number (possibly zero) of optimally encoded output deltas followed by an optimally encoded output delta that itself ends with input delta j. IOW, it must be that f(i, j) is equal to f(i, k) + g(k+1, j) for some k, and there are at most n values of k that we need to try, so we can compute each value of f() in O(n); there are O(n^2) values to compute, so O(n^3) time overall. f(1, n) is then the minimum number of bytes needed to encode the entire list of input deltas, and standard backtracing through the DP matrix can be used to recover the actual sequence of output deltas.